from .baseApi import BaseAPI
import re
import base64
import json
import pycurl


class UIA(BaseAPI):
    def __init__(self):
        super(BaseAPI, self).__init__()

    def login_uia(self, username, password):
        login_html = self.request("http://my.ouc.edu.cn")
        result = re.search('<input type="hidden" name="lt" value="(.+)" />', login_html)
        if result:
            login_code = result.group(1)
        # #print(login_code)
        # result = self.request("http://id.ouc.edu.cn:8071/sso/ssoLogin ",
        #                       referer="http://id.ouc.edu.cn:8071/sso/login?service=http%3A%2F%2Fmy.ouc.edu.cn%2Fuser%2FsimpleSSOLogin",
        #                       params=dict(username=username, password=password,
        #                                   lt=login_code, _eventId="submit"))
        # #print(result)
        # result = json.loads(result)
        # if result["state"] is False:
        #     return dict(status=403, message="密码错误,请使用智慧海大账号登录")
        result = self.request(
            "http://id.ouc.edu.cn:8071/sso/login?service=http%3A%2F%2Fmy.ouc.edu.cn%2Fuser%2FsimpleSSOLogin",
            referer="http://id.ouc.edu.cn:8071/sso/login?service=http%3A%2F%2Fmy.ouc.edu.cn%2Fuser%2FsimpleSSOLogin",
            params=dict(username=username, password=base64.b64encode(password.encode()),
                        lt=login_code, _eventId="submit"))
        """
        <div class="username">罗梁</div><div class="role">教授</div><div class="dep">信息科学与技术学院</div>
        """

        if username in result:
            xm = ""
            zy = ""
            try:
                xm = re.search(r'<div class="username">(.+?)</div>', result).group(1)
                zy = re.search(r'<div class="dep">(.+?)</div>', result).group(1)
            except:
                pass
            return dict(status=200, message="登陆成功", name=xm, zy=zy, xh=username)
        else:
            return dict(status=203, message="系统错误，请联系管理员")

    def get_user_info(self):
        url = "http://my.ouc.edu.cn/c/portal/baseUserInfoAction"
        html = self.request(url)
        result = json.loads(html)
        return result

    def login_yjs(self, xh):
        self.http.set_option(pycurl.MAXREDIRS, 10)
        html = self.request("http://graduate.ouc.edu.cn/ssoLogin.do")

    def login_jwc(self, xh):
        self.request("http://jwgl.ouc.edu.cn/login")

    def get_weeks(self, s):
        res = []
        if "-" in s:
            s = s.replace("(", "")
            s = s.replace("周)", "").split("-")
            for x in range(int(s[0]), int(s[1]) + 1):
                res.append(str(int(x) - 4))
        elif "|" in s:
            s = s.replace("(第", "")
            s = s.replace("周)", "").split("|")
            for x in s:
                res.append(str(int(x) - 4))
        return ",".join(res)

    def get_day(self, strr):
        result = re.findall("星期(.)", strr)
        days = {"一": 1, "二": 2, "三": 3,
                "四": 4, "五": 5, "六": 6,
                "日": 7}
        if result:
            return days.get(result[0])
        else:
            return -1

    def get_time(self, s):
        result = re.findall("第(\d+)-(\d+)节", s)
        if result:
            return int(result[0][0]), int(result[0][1])
        else:
            # print(s)
            return -1, -1

    def get_telphone(self, type=0, key=""):
        url = "http://my.ouc.edu.cn/portal_bmaddressbook/struts/portal_bmaddressbook_tree!getTree"
        return json.loads(self.request(url, params={"type": type, "keyvalue": key}))

    def log_pga(self):
        url = "http://id.ouc.edu.cn:8071/app/forward.action?id=5e431e3164cdc2e80164ffe7195f3cf9&userId=2000001"
        self.request(url)
        data = self.request(url="http://pgs.ouc.edu.cn/", referer=url)
        if "page/home.htm" in data:
            return True
        else:
            return False

    def get_yjs_course(self, xn, xq, max_page=117):
        url = "http://pgs.ouc.edu.cn/py/page/teacher/lnsjCxdc.htm?operateType=search&key=&kckkxj=11&kkyx=-1&kcxz=-1&skyy=-1&tskc=&kcbh=&kcmc=&jsgh=&jsxm=&pageId={}"
        courses = []
        for index in range(1, max_page + 1):
            html = self.request(url.format(index))
            # print(index)
            result = self.get_table(html)
            for x in result[0]:
                if x[0] != str(xn):
                    break
                temp = x[-1].split("||")
                classRoom = temp[-1].replace(")", "")
                weeks = self.get_weeks(temp[0])
                times = self.get_time(temp[2])
                day = self.get_day(temp[1])
                course = dict(classNum=x[2], xn=xn, xq=xq,
                              classRoom=classRoom, teacher=x[8],
                              name=x[3], weeks=weeks,
                              num=times[1] - times[0], day=day,
                              begin=times[0], type="yjs",
                              orgin=x[-1])
                courses.append(course)
        return courses
